package com.uas.erp.manage.client.api.v1;

import com.uas.erp.manage.client.entity.Client;
import com.uas.erp.manage.client.service.ClientService;
import com.uas.erp.manage.client.web.ResponseWrap;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.http.ResponseEntity;
import org.springframework.web.bind.annotation.GetMapping;
import org.springframework.web.bind.annotation.PostMapping;
import org.springframework.web.bind.annotation.RequestMapping;
import org.springframework.web.bind.annotation.RestController;

/**
 * Created by Pro1 on 2017/6/26.
 */
@RestController
@RequestMapping(path = "/v1/client")
public class ClientController {

    @Autowired
    private ClientService clientService;

    @GetMapping
    public ResponseEntity getClient() {
        return ResponseWrap.ok(clientService.getClient());
    }

    @PostMapping
    public ResponseEntity saveClient(Client client) {
        clientService.safetySave(client);
        return ResponseWrap.ok();
    }

    @GetMapping(path = "/info")
    public ResponseEntity getClientInfo() {
        return ResponseWrap.ok(clientService.getClientInfo());
    }

    @PostMapping(path = "/init")
    public ResponseEntity initClient() {
        clientService.initClient();
        return ResponseWrap.ok();
    }

}
