package com.uas.erp.manage.client.api.v1;

import com.uas.erp.manage.client.entity.Setting;
import com.uas.erp.manage.client.service.SettingService;
import com.uas.erp.manage.client.web.ResponseWrap;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.http.ResponseEntity;
import org.springframework.util.Assert;
import org.springframework.util.StringUtils;
import org.springframework.web.bind.annotation.*;

import java.util.List;

/**
 * Created by Pro1 on 2017/6/22.
 */
@RestController
@RequestMapping(path = "/v1/setting")
public class SettingControllerV1 {

    @Autowired
    private SettingService settingService;

    /**
     * 取配置列表
     * @param group 组别
     * @return
     */
    @GetMapping(path = "/list")
    public ResponseEntity getSettings(String group) {
        List<Setting> settings = null;
        if (StringUtils.isEmpty(group)) {
            settings = settingService.findAll();
        } else {
            settings = settingService.findByGroup(group);
        }
        return ResponseWrap.ok(settings);
    }

    @GetMapping(path = "/{key}")
    public ResponseEntity getSetting(@PathVariable("key") String key) {
        return ResponseWrap.ok(settingService.findOne(key));
    }

    @PostMapping
    public ResponseEntity saveSetting(Setting setting) {
        settingService.save(setting);
        return ResponseWrap.ok();
    }

    @DeleteMapping(path = "/{key}")
    public ResponseEntity deleteSetting(@PathVariable("key") String key) {
        Setting setting = settingService.findOne(key);
        Assert.notNull(setting);
        settingService.delete(setting);
        return ResponseWrap.ok();
    }

}
