package com.uas.erp.manage.client.entity;

import javax.persistence.*;

/**
 * Created by Pro1 on 2017/6/19.
 */
@Entity
@Table(indexes = {@Index(columnList = "groupId,artifactId", unique = true)})
public class Artifact {

    @Id
    @GeneratedValue
    private Long id;

    private String repoType;

    private String groupId;

    private String artifactId;

    private String packaging;

    private String description;

    private String lastVersion;

    private Long lastUpdateTime;

    private Long lastVersionTime;

    private Boolean autoUpdate;

    public Long getId() {
        return id;
    }

    public void setId(Long id) {
        this.id = id;
    }

    public String getGroupId() {
        return groupId;
    }

    public void setGroupId(String groupId) {
        this.groupId = groupId;
    }

    public String getArtifactId() {
        return artifactId;
    }

    public void setArtifactId(String artifactId) {
        this.artifactId = artifactId;
    }

    public String getDescription() {
        return description;
    }

    public void setDescription(String description) {
        this.description = description;
    }

    /**
     * 最新版本
     * @return
     */
    public String getLastVersion() {
        return lastVersion;
    }

    public void setLastVersion(String lastVersion) {
        this.lastVersion = lastVersion;
    }

    public void setLast(ArtifactItem artifactItem) {
        this.lastVersion = artifactItem.getVersion();
        this.lastVersionTime = artifactItem.getVersionTime();
        this.lastUpdateTime = artifactItem.getUpdateTime();
    }

    /**
     * 更新时间
     * @return
     */
    public Long getLastUpdateTime() {
        return lastUpdateTime;
    }

    public void setLastUpdateTime(Long lastUpdateTime) {
        this.lastUpdateTime = lastUpdateTime;
    }

    /**
     * 版本提交时间
     * @return
     */
    public Long getLastVersionTime() {
        return lastVersionTime;
    }

    public void setLastVersionTime(Long lastVersionTime) {
        this.lastVersionTime = lastVersionTime;
    }

    public String getRepoType() {
        return repoType;
    }

    public void setRepoType(String repoType) {
        this.repoType = repoType;
    }

    public boolean isAutoUpdate() {
        return null != autoUpdate && autoUpdate.booleanValue();
    }

    public void setAutoUpdate(Boolean autoUpdate) {
        this.autoUpdate = autoUpdate;
    }

    public String getPackaging() {
        return packaging;
    }

    public void setPackaging(String packaging) {
        this.packaging = packaging;
    }

    public static enum RepoType {
        MAVEN,DIFF
    }
}
