package com.uas.erp.manage.client.entity;

import com.uas.ops.diff.domain.Manifest;
import com.uas.erp.manage.client.domain.MavenMetadata;
import com.uas.erp.manage.client.util.DateTimeUtils;

import javax.persistence.*;
import java.util.Date;

/**
 * Created by Pro1 on 2017/6/19.
 */
@Entity
@Table(indexes = {@Index(columnList = "artifactId,version", unique = true)})
public class ArtifactItem {
    public ArtifactItem() {
    }

    public ArtifactItem(Artifact artifact, Manifest manifest) {
        this.artifactId = artifact.getId();
        this.version = manifest.getVersion();
        this.versionTime = manifest.getLastChanged();
        this.updateTime = new Date().getTime();
    }

    public ArtifactItem(Artifact artifact, MavenMetadata metadata) throws Exception{
        this.artifactId = artifact.getId();
        this.version = metadata.getVersioning().getLatest();
        this.versionTime = DateTimeUtils.parseDateTime(metadata.getVersioning().getLastUpdated(), "yyyyMMddHHmmss").getTime();
        this.updateTime = new Date().getTime();
    }

    @Id
    @GeneratedValue
    private Long id;

    private Long artifactId;

    private String version;

    private Long versionTime;

    private Long updateTime;

    public Long getId() {
        return id;
    }

    public void setId(long id) {
        this.id = id;
    }

    public Long getArtifactId() {
        return artifactId;
    }

    public void setArtifactId(Long artifactId) {
        this.artifactId = artifactId;
    }

    public String getVersion() {
        return version;
    }

    public void setVersion(String version) {
        this.version = version;
    }

    public Long getVersionTime() {
        return versionTime;
    }

    public void setVersionTime(Long versionTime) {
        this.versionTime = versionTime;
    }

    public Long getUpdateTime() {
        return updateTime;
    }

    public void setUpdateTime(Long updateTime) {
        this.updateTime = updateTime;
    }
}
