package com.uas.erp.manage.client.entity;

import org.springframework.util.StringUtils;

import javax.persistence.*;
import java.util.Set;

/**
 * Created by Pro1 on 2017/6/19.
 */
@Entity
public class Container {

    @Id
    @GeneratedValue
    private Long id;

    private String type;

    private String host;

    @Column(unique = true)
    private String home;

    private Integer port;

    @Column(unique = true)
    private String description;

    private String status;

    private String startCommand;

    private String stopCommand;

    private String statusCommand;

    private String processCommand;

    private String deployCommand;

    private String webappsHome;

    @OneToMany(cascade = { CascadeType.ALL }, fetch = FetchType.LAZY)
    @JoinColumn(name="parentId")
    private Set<Container> nodes;

    public Container() {

    }

    public Container(String home) {
        this.home = home;
        this.status = Status.UNRECOGNIZED.name();
    }

    public Long getId() {
        return id;
    }

    public void setId(Long id) {
        this.id = id;
    }

    public String getType() {
        return type;
    }

    public void setType(String type) {
        this.type = type;
    }

    public String getHome() {
        return home;
    }

    public void setHome(String home) {
        this.home = home;
    }

    public String getDescription() {
        return description;
    }

    public void setDescription(String description) {
        this.description = description;
    }

    public String getStatus() {
        return status;
    }

    public void setStatus(String status) {
        this.status = status;
    }

    public Integer getPort() {
        return port;
    }

    public void setPort(Integer port) {
        this.port = port;
    }

    public String getStartCommand() {
        return startCommand;
    }

    public void setStartCommand(String startCommand) {
        this.startCommand = startCommand;
    }

    public String getStopCommand() {
        return stopCommand;
    }

    public void setStopCommand(String stopCommand) {
        this.stopCommand = stopCommand;
    }

    public String getStatusCommand() {
        return statusCommand;
    }

    public void setStatusCommand(String statusCommand) {
        this.statusCommand = statusCommand;
    }

    public String getProcessCommand() {
        return processCommand;
    }

    public void setProcessCommand(String processCommand) {
        this.processCommand = processCommand;
    }

    public String getHost() {
        return host;
    }

    public void setHost(String host) {
        this.host = host;
    }

    public String getDeployCommand() {
        return deployCommand;
    }

    public void setDeployCommand(String deployCommand) {
        this.deployCommand = deployCommand;
    }

    public String getWebappsHome() {
        return webappsHome;
    }

    public void setWebappsHome(String webappsHome) {
        this.webappsHome = webappsHome;
    }

    /**
     * 集群节点
     * @return
     */
    public Set<Container> getNodes() {
        return nodes;
    }

    public void setNodes(Set<Container> nodes) {
        this.nodes = nodes;
    }

    public boolean isCluster() {
        return Type.CLUSTER.equals(Type.valueOf(this.getType()));
    }

    public boolean isRemote() {
        return !StringUtils.isEmpty(this.host) && !"localhost".equals(this.host)
                && !"127.0.0.1".equals(this.host);
    }

    public static enum Type {
        TOMCAT,JBOSS,SPRING_BOOT,CLUSTER,OTHER
    }

    public static enum Status {
        RUNNING,STOPPED,UNRECOGNIZED
    }
}
