package com.uas.erp.manage.client.entity;

import org.springframework.util.Assert;
import org.springframework.util.StringUtils;

import javax.persistence.Column;
import javax.persistence.Entity;
import javax.persistence.Id;

/**
 * 配置
 * Created by Pro1 on 2017/6/19.
 */
@Entity
public class Setting {

    @Id
    private String key;

    @Column(name = "group_")
    private String group;

    private static final String default_group = "default";

    private String description;
    @Column(name = "value_")
    private String value;

    public Setting() {
    }

    public Setting(String key, String value) {
        this(null, key, null, value);
    }

    public Setting(String key, String description, String value) {
        this(null, key, description, value);
    }

    public Setting(String group, String key, String description, String value) {
        this.group = StringUtils.isEmpty(group) ? default_group : group;
        Assert.notNull(key);
        this.key = key;
        this.description = StringUtils.isEmpty(description) ? key : description;
        this.value = value;
    }

    public String getKey() {
        return key;
    }

    public void setKey(String key) {
        this.key = key;
    }

    public String getDescription() {
        return description;
    }

    public void setDescription(String description) {
        this.description = description;
    }

    public String getValue() {
        return value;
    }

    public void setValue(String value) {
        this.value = value;
    }

    /**
     * 分组
     * @return
     */
    public String getGroup() {
        return group;
    }

    public void setGroup(String group) {
        this.group = group;
    }
}
