package com.uas.erp.manage.client.plugins;

import com.uas.erp.manage.client.entity.Project;
import com.uas.erp.manage.client.entity.ProjectResourceReplace;
import com.uas.erp.manage.client.service.LocalRepositoryService;
import org.springframework.util.CollectionUtils;
import org.springframework.util.FileCopyUtils;

import java.io.File;

/**
 * Created by Pro1 on 2017/6/23.
 */
public class ProjectResourceReplacePlugin extends ProjectBuildPlugin{

    private LocalRepositoryService localRepository;

    public ProjectResourceReplacePlugin(Project project, LocalRepositoryService localRepository) {
        super(project);
        this.localRepository = localRepository;
    }

    @Override
    public void onBuild(File target) throws Exception {
        if (!CollectionUtils.isEmpty(project.getResourceReplaces())) {
            for (ProjectResourceReplace replace:project.getResourceReplaces()) {
                File file = localRepository.getAttach(replace.getFilePath());
                if (file.exists()) {
                    FileCopyUtils.copy(file, new File(target.getAbsolutePath() + replace.getPath()));
                }
            }
        }
    }
}
