package com.uas.erp.manage.client.service;

import com.uas.erp.manage.client.domain.ClientInfo;
import com.uas.erp.manage.client.web.ResultWrap;
import org.apache.log4j.Logger;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.stereotype.Service;
import org.springframework.web.client.RestTemplate;

/**
 * Created by Pro1 on 2017/6/19.
 */
@Service
public class RemoteOpsService {

    @Autowired
    private RestTemplate restTemplate;

    @Autowired
    private SettingService settingService;

    private Logger logger = Logger.getLogger(RemoteOpsService.class);

    private String getOpsUrl() {
        return settingService.getValue("ops.url");
    }

    public void pushClientInfoToRemote(ClientInfo clientInfo){
        ResultWrap<String> result = restTemplate.postForObject(getOpsUrl() + "/client/info", clientInfo, ResultWrap.class);
        if (!result.isSuccess()) {
            logger.error("pushClientInfoToRemote return error: [" + result.getMessage() + "]");
        }
    }

}
