package com.uas.erp.manage.client.service;

import com.uas.erp.manage.client.entity.Setting;
import com.uas.erp.manage.client.repository.SettingRepository;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.stereotype.Service;

import java.util.List;

/**
 * Created by Pro1 on 2017/6/19.
 */
@Service
public class SettingService {

    @Autowired
    private SettingRepository settingRepository;

    public List<Setting> findAll() {
        return settingRepository.findAll();
    }

    public List<Setting> findByGroup(String group) {
        return settingRepository.findByGroupOrderByKey(group);
    }

    public Setting findOne(String key) {
        return settingRepository.findOne(key);
    }

    public String getValue(String key) {
        Setting setting = settingRepository.findOne(key);
        return null != setting ? setting.getValue() : null;
    }

    public void save(Setting setting) {
        settingRepository.save(setting);
    }

    public void save(List<Setting> settings) {
        settingRepository.save(settings);
    }

    public void delete(Setting setting) {
        settingRepository.delete(setting);
    }

    public void deleteAll() {
        settingRepository.deleteAll();
    }

}
