package com.uas.erp.manage.client.task;

import com.uas.erp.manage.client.entity.Artifact;
import com.uas.erp.manage.client.service.ArtifactService;

import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.scheduling.annotation.Scheduled;
import org.springframework.stereotype.Component;
import org.springframework.util.CollectionUtils;

import java.util.List;

/**
 * Created by Pro1 on 2017/6/17.
 */
@Component
public class ScheduledArtifactUpdater {

    @Autowired
    private ArtifactService artifactService;

    @Scheduled(cron = "0 0 1 * * *")
    public void update() throws Exception{
        List<Artifact> artifacts = artifactService.getArtifacts();
        if (!CollectionUtils.isEmpty(artifacts)) {
            for (Artifact artifact:artifacts) {
                if (artifact.isAutoUpdate())
                    artifactService.update(artifact);
            }
        }
    }

}
