package com.uas.erp.manage.client.task;

import com.uas.erp.manage.client.entity.Container;
import com.uas.erp.manage.client.service.ContainerService;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.scheduling.annotation.Scheduled;
import org.springframework.stereotype.Component;
import org.springframework.util.CollectionUtils;

import java.util.ArrayList;
import java.util.List;

/**
 * Created by Pro1 on 2017/6/19.
 */
@Component
public class ScheduledContainerRefresher {

    @Autowired
    private ContainerService containerService;

    /**
     * 每分钟检测容器状态
     * @throws Exception
     */
    @Scheduled(cron = "0 * * * * *")
    public void refreshStatus() throws Exception{
        List<Container> containers = containerService.findAll();
        if (!CollectionUtils.isEmpty(containers)) {
            List<Container> changed = new ArrayList<Container>();
            for (Container container:containers) {
                String status = containerService.getStatus(container);
                if (!status.equals(container.getStatus())) {
                    container.setStatus(status);
                    changed.add(container);
                }
            }
            if (!CollectionUtils.isEmpty(changed)) {
                containerService.save(changed);
            }
        }
    }

}
