package com.uas.erp.manage.client.task;

import com.uas.erp.manage.client.domain.ClientInfo;
import com.uas.erp.manage.client.service.ClientService;
import com.uas.erp.manage.client.service.RemoteOpsService;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.scheduling.annotation.Scheduled;
import org.springframework.stereotype.Component;

/**
 * Created by Pro1 on 2017/6/19.
 */
@Component
public class ScheduledRemotePusher {

    @Autowired
    private ClientService clientService;

    @Autowired
    private RemoteOpsService remoteOpsService;

    /**
     * 每5分钟报告一次
     * @throws Exception
     */
    @Scheduled(cron = "0 */5 * * * *")
    public void pushClientInfoToRemote() throws Exception{
        ClientInfo info = clientService.getClientInfo();
        if (null != info) {
            remoteOpsService.pushClientInfoToRemote(info);
        }
    }

}
