package com.uas.erp.manage.client.util;

import org.springframework.util.StreamUtils;

import java.io.*;
import java.util.zip.ZipEntry;
import java.util.zip.ZipInputStream;
import java.util.zip.ZipOutputStream;

/**
 * Created by Pro1 on 2017/6/13.
 */
public class ZipUtils {

    public static void unzip(byte[] zipData, String targetPath) throws IOException{
        ZipInputStream in = new ZipInputStream(new ByteArrayInputStream(zipData));
        ZipEntry entry;
        File file;
        BufferedOutputStream out = null;
        while((entry = in.getNextEntry())!=null && !entry.isDirectory()){
            file = new File(targetPath, entry.getName());
            if (!file.getParentFile().exists()) {
               file.getParentFile().mkdirs();
            }
            out = new BufferedOutputStream(new FileOutputStream(file));
            StreamUtils.copy(in, out);
            out.flush();
        }
        in.closeEntry();
        IOUtils.closeQuietly(in, out);
    }

    public static void zip(File source, File zipFile) throws IOException{
        if (source.exists()) {
            FileOutputStream fileOut = new FileOutputStream(zipFile);
            ZipOutputStream zipOut = new ZipOutputStream(fileOut);
            try {
                addEntry(null, source, zipOut);
                // 如果希望保留sourcePath文件夹，使用addEntry("", source, zipOut);
            } finally {
                IOUtils.closeQuietly(zipOut, fileOut);
            }
        }
    }

    private static void addEntry(String entryPath, File source, ZipOutputStream zipOut) throws IOException {
        String entry = null == entryPath ? "" : (entryPath + source.getName());
        if (source.isDirectory()) {
            entry = entry.isEmpty() ? entry : (entry + File.separator);
            for (File file : source.listFiles()) {
                addEntry(entry, file, zipOut);
            }
        } else {
            FileInputStream fileIn = new FileInputStream(source);
            try {
                zipOut.putNextEntry(new ZipEntry(entry));
                StreamUtils.copy(fileIn, zipOut);
                zipOut.closeEntry();
            } finally {
                IOUtils.closeQuietly(fileIn);
            }
        }
    }

}
